#include <dir.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include "findfile.h"

static int ok_next = 0;
char path[(MAXDRIVE-1)+(MAXDIR-1)+(MAXFILE-1)+(sizeof '.')+(MAXEXT-1) + 1];
static int pl;
static struct ffblk dir;

/* return first file that matches a file specification */

const char *findfirstfile(const char *fn)
{
    register const char *cp;

    pl = strlen(fn);    /* calculate length of path portion */
    for(cp = fn + pl - 1; cp >= fn && *cp != '\\' && *cp != ':'; --cp, --pl)
        ;
    if(pl > sizeof(path) - sizeof(dir.ff_name) ||
    findfirst(fn, &dir, FA_NORMAL) != 0) {
        ok_next = 0;    /* don't allow findnextfile() */
        return 0;       /* no first file */
        }
    if(pl != 0)
        memcpy(path, fn, pl);
    memcpy(path + pl, dir.ff_name, sizeof(dir.ff_name));
    ok_next = 1;        /* allow findnextfile() */
    return path;
}


/* return next file that matches a file specification */

const char *findnextfile(void)
{

    if(ok_next) {
        if(findnext(&dir) == 0) {
            memcpy(path + pl, dir.ff_name, sizeof(dir.ff_name));
            return path;
            }
        ok_next = 0;    /* don't allow any more findnextfile() calls */
        }
    return 0;           /* no next file */
}
