#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <process.h>
#include <errno.h>
#include <dir.h>
#include "findfile.h"

static char *my_name;

int main(int argc, char *argv[])
{
	char *thisfile;
	char drive[MAXDRIVE];
	char path[MAXDIR];
	char fname[MAXFILE];
	char fext[MAXEXT];
	char fname_fext[(MAXFILE-1)+(MAXEXT-1)+(sizeof '.')+1];
	char command[128];
	char syscommand[256];
	char *pathstart;
	char *filestart;
	register char *cp, *cp2;
	char *arg;
	int l;
	int sw;
	static int xct = 1;
	int xct_command(const char *);
	void error(void);

	my_name = argv[0];
	--argc;
	++argv;

	/* process switches: */
	while(argc != 0 && (cp = *argv)[0] == '-') {
		while((sw = *++cp) != '\0') {
			switch(sw) {
				case 'n':   xct = 0;    /* don't execute */
							break;

				default:    error();
				}
			}
		--argc;
		++argv;
		}

	if(argc < 2)
		error();

	thisfile = (char *)findfirstfile(*argv);
	if(thisfile == 0) {
		fprintf(stderr, "No files: %s\n", *argv);
		return 1;
		}
	--argc;
	++argv;

    strcpy(command, *argv);
    --argc;
    ++argv;

    while(argc != 0) {
        strcat(command, " ");
        strcat(command, *argv);
        --argc;
        ++argv;
        }

    /*
		findfirstfile and findnextfile will always return same drive and
        path prefix, if any:
    */
    if((cp = strchr(thisfile, ':')) != 0) {
        l = cp - thisfile;
        memcpy(drive, thisfile, l);
        drive[l] = '\0';
        pathstart = cp + 1;
        }
    else {
        drive[0] = '\0';
        pathstart = thisfile;
        }
	cp = strrchr(pathstart, '\\');
    if(cp != 0) {
        l = cp + 1 - pathstart;
        memcpy(path, pathstart, l);
        path[l] = '\0';
        filestart = cp + 1;
        }
    else {
        path[0] = '\0';
        filestart = pathstart;
        }

    do {
		strcpy(fname_fext, filestart);
        cp = strchr(filestart, '.');
        if(cp != 0) {
            l = cp - filestart;
            memcpy(fname, filestart, l);
            fname[l] = '\0';
			strcpy(fext, cp + 1);
            }
        else {
            strcpy(fname, filestart);
			fext[0] = '\0';
            }
        for(cp = syscommand, cp2 = command; *cp2 != '\0'; ) {
			if(*cp2 != '%')
                *cp++ = *cp2++;
            else {
                ++cp2;
                switch(*cp2++) {
                    case '%':   *cp++ = '%';
                    default:    arg = 0; break;

                    case 's':   arg = thisfile; break;
                    case 'd':   arg = drive; break;
                    case 'p':   arg = path; break;
					case 'f':   arg = fname_fext; break;
                    case 'n':   arg = fname; break;
					case 'x':   arg = fext; break;
	                }
                if(arg != 0) {
                    l = strlen(arg);
                    memcpy(cp, arg, l);
                    cp += l;
                    }
                }
            }
        *cp = '\0';
        puts(syscommand);
        if(xct)
            xct_command(syscommand);
		} while((thisfile = (char *)findnextfile()) != 0);
    return 0;
}

int xct_command(const char *command)
{
    char cmd[256];
    char *argv[64];
    int argc;
    char *cp;
    int rc;

    if(strlen(command) >= sizeof(cmd))
        return system(command);
    strcpy(cmd, command);
    argc = 0;
    cp = strtok(cmd, " ");
    while(cp != 0) {
        if(argc >= sizeof(argv)/sizeof(argv[0]) - 1)
            return system(command);
        argv[argc++] = cp;
        cp = strtok(0, " ");
        }
    argv[argc] = 0;
    errno = 0;
    rc = spawnvp(P_WAIT, argv[0], argv);
    if(rc != -1 || errno != ENOENT)
        return rc;
    return system(command);
}


static void error(void)
{
    fprintf(stderr, "Usage is: %s [-n] file-spec command\n", my_name);
    exit(1);
}

