#include "WWLocal.h"
#pragma hdrstop

class FSE
  {
      LogicalWindow* W;
      CSVector V;
      int TopLine;
      int CurLine;
      String120 Mask;
      int Y(){return (W->TextCursorPos().Y());}
      int X(){return (CurLine-TopLine+1);}
      int CPos(){return (CurLine-TopLine);}
      int Wide(){return W->Wide();}
      int High(){return W->High();}
      int MaxTopLine(){return (Max(V.Size()-(W->High()),0));}
      void GoUp();
      void GoDown();
      void PageUp();
      void PageDown();
      KeyType EditLine();
      void CheckOverBuff();
      void InsertLine(int L,const char* S=NULL);
      void UpdateScreen();
    public:
      FSE(LogicalWindow* Win,String &S);
      KeyType Activate();
      void Done();
      void Done(String& S);
  };

FSE::UpdateScreen()
  {
    W->Clear();
    int I;
    for(I=TopLine;I<Min(High()+TopLine,V.Size());I++)
        W->Display(V(I),1,I-TopLine+1);
  }

FSE::FSE(LogicalWindow* Win,String &S)
  {
    W=Win;
    TopLine=0;
    CurLine=0;
    int Pos=0;
    Mask=StringOf(Wide(),'#');
    while(Pos<S.Length())
      {
        char* CS=(char*)malloc(Wide()+1);
        int X=S.Index('\r',Pos);
        int Len=X-Pos;
        if (Len<=Wide())
          {
            strncpy(CS,&S[Pos],Len);
            CS[Len]='\0';
            Pos+=Len+1;
          }
        else
          {
            while ((X>Pos)&&(S(X)!=' ')) X--;
            if (X==Pos)
              {
                strncpy(CS,&S[Pos],Wide());
                Pos+=Wide();
              }
            else
              {
                Len=X-Pos;
                strncpy(CS,&S[Pos],Len);
                CS[Len]='\0';
                Pos+=Len+1;  // skip over space
              }
          }
        CS[Wide()]='\0';
        V+=CS;
      }
  }

FSE::InsertLine(int L,const char* S)
  {
    CS=(char*)malloc(Wide()+1);
    if (S==NULL) CS[0]='\0';
    else
      {
        strncpy(CS,S,Min(strlen(S),Wide()));
        CS[Wide()]='\0';
      }
    V.Insert(CS,L);
  }

extern String OverBuff;

void FSE::CheckOverBuff()
  {
    if (OverBuff.Size()>0)
      {
        xxx
        InsertLine(CurLine+1,OverBuff);
      }
  }

void FSE::GoUp()
  {

  }

void FSE::GoDown()
  {

  }

void FSE::PageUp()
  {

  }

void FSE::PageDown()
  {

  }

KeyType FSE::EditLine()
  {
    EditStringRec ESR(*W,V(CurLine),Mask,Point(1,Y()));
    ESR.SetAutoClearMode(Off);
    ESR.SetHomeCPosMode(Off);
    ESR.SetCPos(CPos());
    KeySetType KS(ArrowUpKey,ArrowDownKey,FullStringExit,PageUpKey,PageDownKey,F2Key);
    ESR.AddExitKeys(KS);
    KeyType K=ESR.Activate();
    if (K!=EscKey)
      {
        CheckOverBuff();
      }
  }

KeyType FSE::Activate()
  {
    VideoAtt A(Yellow,Black);
    W->SetLiveEditAtt(A);
    W->SetDeadEditAtt(A);
    W->Clear(A);
    int I;
    For(I,Min(High(),V.Size())) W->Display(V(I),1,I+1);
    KeyType K;
    Bool Done=False;
    while(!Done)
      {
        K=EditLine();
        switch(int(K))
          {
            case EscKey:
            case F2Key:   Done=True; break;
            case EnterKey:
            case ArrowUpKey:
            case ArrowDownKey:
            case PageUpKey:
            case PageDownKey:
            case FullStringExit:
          }
      }

  }

void FSE::Done()
  {
    int I;
    For(I,V.Size) free(V(I));
  }

void FSE::Done(String& S)
  {
    S.Clip(0);
    int I;
    For(I,V.Size())
      {
        S+=V(I);
        S+='\r';
        free(V(I));
      }
  }

KeyType LogicalWindow::Edit(String& S)
  {
    FSE X(this,S);
    KeyType K=X.Activate();
    if (K!=EscKey) S=Done(S);
    else Done();
    return K;
  }

