#include <math.h>
#include <WDOS.h>
#include <WW.h>
#include <WWMenu.h>

// copyright (c) 1992, 1993 by Paul Wheaton

#ifdef UseGraphics
  extern Bool SmoothScroll;
#else
  void TextModeCursorOn(Bool Ins);
  void TextModeCursorOff();
#endif

const Bool Highlight=False;

char** ConvertStringToArray(const char* S);
  // returns an array of pointers which must be eventually deleted
int ArrayLen(void** Items);        // counts up to NULL
int StringArrayLen(char** Items);  // counts up to NULL or empty string
void TestForExit(Bool& Done, KeyType& Key);
Window* MakeWinOText(LogicalWindow& PW,const char* St,int X,int Y,VideoAtt Att,int MinWide);

void AlignWinBoundry(Rect&,const Rect&);

typedef struct
  {
    char Ch;
    Byte Att;
  } VideoPiece;

typedef VideoPiece ScreenLineType[80];
typedef ScreenLineType far * ScreenPtrType;
extern ScreenPtrType Screen1;
extern ScreenPtrType Screen2;

typedef struct _BootRecType
  {
    Byte          Ver;  // in case this rec gets updated.  Will accept 0 now
    Bool          Dual; // Are there two monitors?
    int          DeviceNum;  // The primary monitor type
    DefaultAttRec DAtt;  // primary monitor colors
    int          Device2Num; // The secondary monitor type
    DefaultAttRec D2Att; // secondary monitor colors
    char          ClientName[61];  // such as "The State of Maryland"
  } BootRecType;

extern BootRecType BootRec;

void RemoveWinFromList(WindowRec* W);
void AddWinToList(WindowRec* W);
extern Byte* OrigScreen1;
extern Point OrigCursorPos1;

int TextVideoMode();

typedef struct _HotKeyRec
  {
    Word K;
    VoidFuncPtr P;
  } HotKeyRec;

CreateRefVectorClass(HotVec,HotKeyRec);

extern HotVec Hots;

void TestForHotKey(KeyType& K,Bool FromKeyPressed=No);

extern String WWFileName;

